package zero1hd.polyjet.audio.map;

<<<<<<< HEAD
=======
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.audio.Music;
import com.badlogic.gdx.math.MathUtils;
>>>>>>> parent of e4359f4... tuning and adjustments
import com.badlogic.gdx.utils.Array;

import zero1hd.polyjet.audio.AudioData;
import zero1hd.polyjet.entity.Entities;

public class GamePlayMap {
	private AudioData playableClip;
	private float playTime;
	private Array<EntitySpawnInfo> spawnList;
	private boolean building;
	private int constIndex;
	private int index;
	/**
	 * GamePlayMap is what the game area will use to generate entities and judge current audio data
	 * @param audioData audio data
	 */
	public GamePlayMap(AudioData audioData) {
		this.playableClip = audioData;
		spawnList = new Array<>();
	}
	
	/**
	 * returns audio data
	 * @return
	 */
	public AudioData getMusicData() {
		return playableClip;
	}
	
	/**
	 * returns the runtime time of the overall song
	 * @return
	 */
	public float getPlayTime() {
		return playTime;
	}

	/**
	 * call this when beginning to build map
	 */
	public void beginBuild() {
		building = true;
		index = 0;
		constIndex = 0;
	}

	/**
	 * call this when finishing building map
	 */
	public void endBuild() {
		building = false;
		index = 0;
		constIndex = 0;
	}

	
	/**
	 * used to add data types for what entity to spawn at that index position
	 * cannot be null.
	 * @param entityType what type of entity to spawn
	 * @param parameters the arguments for the entity. It is important to have the same amount of parameters the entity requires to spawn
	 */
	public void addToMap(Entities entityType, float... parameters) {
		if (building && entityType != null && parameters != null) {
			spawnList.add(new EntitySpawnInfo(entityType, index, parameters));
		}
	}
	
	public void nextWindow() {
		constIndex++;
		index++;
	}
	
	/**
	 * Only works when not started.
	 * retrieve next entity in list.
	 * @return
	 */
	public EntitySpawnInfo nextEntityBatch(boolean indexUpdate) {
		if (!building) {
			if (indexUpdate) {
				constIndex++;
				index++;
			}
			EntitySpawnInfo spawnInfo = spawnList.get(index);
			return spawnInfo;
		} else {
			return null;
		}
	}
	
	public EntitySpawnInfo safeNextEntityBatch() {
		playableClip.readIndexUpdate();
		if (index != playableClip.getReadIndex()) {
			index = playableClip.getReadIndex();
<<<<<<< HEAD
			return nextEntityBatch(false);
=======
			Gdx.app.debug("GPM", "index: " + index);
			return nextEntity(false);
>>>>>>> parent of e4359f4... tuning and adjustments
		} else {
			return null;
		}
	}
	
	/**
	 * set retrieve entity index position.
	 * @param index
	 */
	public void setIndex(int index) {
		this.index = index;
	}
	
	public void restoreIndex() {
		this.index = constIndex;
	}
	
	public int getIndex() {
		return index;
	}
}
